package killer_sokoban;


public class Crate extends Moveable {
	
	private boolean isOnTarget;
	private int onTargetTimes = 0;
	
	
	/**
	 * A láda elveszik, és nem vesz részt a további játékban.
	 */
	public void kill()	{	
		Main.deleteCrate(this);
		super.kill();
	}
	
	/**Ha a láda célmezőre került, akkor kerül meghívásra ez a függvény.
	 * @param w a munkás, aki a tolást indította
	 */
	public void stepOnTarget(Worker w)	{
		w.incrementPoint();
		onTargetTimes++;
		isOnTarget=true;   
	}
	
	/**Ha a láda a célmezőről lekerült, akkor kerül meghívásra ez a függvény.
	 * @param w a munkás, aki a tolást indította
	 */
	public void stepOffTarget(Worker w)	{
		w.decrementPoint();
		onTargetTimes--;
		if(onTargetTimes == 0) isOnTarget=false;
	}
	
	/** Ha a láda kapcsolóra került, akkor kerül meghívásra ez a függvény.
	 * @param s kapcsolót tartalmazó mező
	 */
	public void onSwitch(SwitchField s) {
		s.turnOn();
	}
	
	/**
	 * Kiírja az adattagokat
	 */
	public void printStat()
	{
		super.printStat();
		System.out.println("isOnTarget: " + isOnTarget);
	}
	
	/**
	 * A láda kirajzolásáért felelős
	 */
	@Override
	public void shouldDraw(View view)
	{
		super.shouldDraw(view);
		view.drawCrate();
	}
	
	/**
	 * Jelzi a láda számára, hogy sarokba ragadt.
	 */
	@Override
	public void arriveToCorner() {
		myField.fillCorner();
		Main.deleteCrate(this);
	}
	
	/**
	 * Azt adja vissza, hogy a láda szempontjából befejeződhet-e a játék, azaz hogy nem közvetlenül tolható vagy célmezőn van-e.
	 * @return
	 */
	public boolean couldGameFinish() {return isOnTarget;}
}
