package killer_sokoban;

public class SwitchField extends SimpleField {
	
	private SwitchableHole sHole;
	
	
	/**Ez a függvény azt jelzi a mező számára, hogy szeretnének rálépni.
	 * @param toward melyik irányból szeretnének rálépni
	 * @param w	munkás, aki a tolást indította
	 * @param m	mozgatható dolog a pályán, ez szeretne a mezőre lépni
	 * @return ha befogadja a paraméterül kapott Moveable-t, true-val tér vissza, ellenkező esetben false-szal.
	 */
	@Override
	public boolean accept(Direction toward, Worker w, Moveable m) {

		boolean ret=super.accept(toward, w, m);
		if (ret) myMoveable.onSwitch(this); 

		return ret;
	}
	
	/**
	 * Aktiválja a kapcsolót.
	 */
	public void turnOn() {

		if(sHole!=null)
			sHole.open();

	}
	
	/**
	 * Deaktiválja a kapcsolót.
	 */
	public void turnOff() {

		if(sHole!=null)
			sHole.close();

	}
	
	/**
	 * Eldobja a Moveable-t, az a mező felszabadul.
	 */
	public void dropMoveable()
	{

		super.dropMoveable();
		turnOff();

	}
	
	/**
	 * Beállítja a mező által kapcsolgatott lyukat.
	 * @param sh az új SwitchableHole
	 */
	public void setSHole(SwitchableHole sh) {
		sHole = sh;
	}
	
	/**
	 * Kiírja az adattagokat
	 */
	public void printStat()
	{
		super.printStat();
		System.out.println("sHole: " + Main.getFieldName(sHole));


	}
	
	/**
	 * Kirajzolásért felel
	 */
	@Override
	public void shouldDraw(View view)
	{
		view.drawSwitchField();		
		super.shouldDraw(view);
	}
}

