package killer_sokoban;

public class TargetField extends SimpleField {
		
	/**Ez a függvény azt jelzi a mező számára, hogy szeretnének rálépni.
	 * @param toward melyik irányból szeretnének rálépni
	 * @param w	munkás, aki a tolást indította
	 * @param m	mozgatható dolog a pályán, ez szeretne a mezőre lépni
	 * @return ha befogadja a paraméterül kapott Moveable-t, true-val tér vissza, ellenkező esetben false-szal.
	 */
	@Override
	public boolean accept(Direction toward, Worker w, Moveable m) {
	
		Moveable myEx = myMoveable; //can be null!
		boolean ret=super.accept(toward, w, m);
		if (ret)
		{
			if (myEx!=null) myEx.stepOffTarget(w);
			myMoveable.stepOnTarget(w);
		}
	
		return ret;
	}
	
	/**
	 * Célmező kirajzolásáért felel
	 */
	@Override
	public void shouldDraw(View view)
	{
		view.drawTargetField();		
		super.shouldDraw(view);
	}
}

